/***********************************************************************
	Module MCB.H
	Declarations for MCB constants, structures, and functions.

	Copyright (C) 1994, Brian Sawert.
	All rights reserved.

***********************************************************************/


#ifndef	_MCB_H							/* check for multiple inclusion */
#define _MCB_H

/* -------------------- defines and macros -------------------- */

#define NAME_LEN		8				/* length of name field */

#define ERR_INVALID		1				/* invalid function (non-DOS UMB) */
#define ERR_BADARENA	7				/* memory arena corrupt */


typedef struct tagMCB
	{									/* memory control block structure */
	char mtype;							/* memory block type identifier */
	unsigned owner;						/* PSP of owner */
	unsigned size;						/* memory block size */
	char reserved[3];
	char name[NAME_LEN];				/* owner name if valid */
	} MCB;


/* -------------------- external routines -------------------- */

unsigned get_base_seg(void);			/* get base of allocation chain */
unsigned get_next_seg(unsigned seg, int f_umb);	/* get next block in chain */
int mem_owner_name(unsigned seg, char *pname);	/* get block owner name */
unsigned get_tsr_seg(char *pname, int f_umb);	/* get TSR arena segment */
int get_umb_link(void);					/* get upper memory link status */
int set_umb_link(int f_link);			/* set upper memory link */

#endif
