// wuiname.h - Class to handle WUIMAN object names.
// Copyright (c) 1993 by Ron Burk

#ifndef WUINAME_H
#define WUINAME_H

#ifndef WUISTD_H
    #include "wuistd.h"
#endif


class   TWuiName_;
struct  TWuiNameBase
    {
    TWuiName_   *Handle;
    };

inline
void *operator new(size_t Size, TWuiNameBase *Base)
    {
    ASSERT(Size == sizeof(TWuiNameBase));
    ASSERTDATAPTR(Base);
    return (void *)Base;
    }

class   TWuiName : private TWuiNameBase
    {
public:
    enum    { MAXNAME = (64+1) };
    TWuiName(const char *NewName=0);
    TWuiName(const TWuiName &Other);
    TWuiName(const TWuiNameBase &Other);
    const TWuiName& operator=(const TWuiName &Other);
   ~TWuiName();
    int operator==(const TWuiName &Other) const;
    int operator!=(const TWuiName &Other) const;
    char   *GetName(char *Buffer,
                           int MaxLength=MAXNAME) const;
private:
    void Assert() const;
    };

inline
int operator==(const TWuiName &A, const TWuiName *B)
    {    return A == *B;    }
inline
int operator!=(const TWuiName *A, const TWuiName &B)
    {    return *A == B;    }

inline
int     TWuiName::operator==(const TWuiName &Other) const
    {    MEMBERASSERT();
    return Other.Handle == Handle;
    }
inline
int     TWuiName::operator!=(const TWuiName &Other) const
    {    MEMBERASSERT();
    // define != operator in terms of == operator
    return !(*this == Other);
    }

//typedef const char *TWuiConstName;

#if 0
class   TWuiConstName : private TWuiName
    {
public:
    friend class AWuiObject;
    TWuiConstName();
    TWuiName::operator==;
    TWuiName::operator!=;
    TWuiName::GetName;
    };

#endif

#endif
